/* cosfsa.h, Boone, 09/29/04
   COS message recognizer state table definitions
   Copyright (C) 2004-2009, Dennis Boone, East Lansing, MI */

/* Modifications:
   09/29/04 Boone      Initial coding
   End Modifications */

/* This file is part of xcatctl.

   Xcatctl is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License,
   or (at your option) any later version.

   Xcatctl is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with xcatctl; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

typedef struct
{
	int state;
	int input;
	int dest;
} Cosfsa;

Cosfsa cosfsa[] =
{
	{ 0,	0xfe,	1 },	/* start, saw first intro */
	{ 0,	-1,		0 },	/* start, saw other */
	{ 1,	0xfe,	2 },	/* first intro, saw second intro */
	{ 1,	-1,		0 },	/* first intro, saw other */
	{ 2,	-2,		3 },	/* second intro, saw fromaddr */
	{ 2,	0x00,	3 },	/* second intro, saw fromaddr of 0x00 */
	{ 2,	-1,		0 },	/* second intro, saw other */
	{ 3,	-3,		4 },	/* fromaddr, saw toaddr */
	{ 3,	-1,		0 },	/* fromaddr, saw other */
	{ 4,	0xaa,	5 },	/* toaddr, saw first cmd */
	{ 4,	-1,		0 },	/* toaddr, saw other */
	{ 5,	0x81,	6 },	/* first cmd, saw second cmd */
	{ 5,	-1,		0 },	/* first cmd, saw other */
	{ 6,	-4,		7 },	/* second cmd, saw mode # (00-1f) */
	{ 6,	-1,		0 },	/* second cmd, saw other */
	{ 7,	0x00,	8 },	/* mode #, saw sig lost */
	{ 7,	0x01,	9 },	/* mode #, saw sig found */
	{ 7,	-1,		0 },	/* mode #, saw other */
	{ 8,	0xfd,	10 },	/* sig lost, saw frame end */
	{ 8,	-1,		0 },	/* sig lost, saw other */
	{ 9,	0xfd,	11 },	/* sig found, saw frame end */
	{ 9,	-1,		0 },	/* sig found, saw other */
	{ 10,	0xfe,	1 },	/* sig lost announce, saw first intro */
	{ 10,	-1,		0 },	/* sig lost announce, saw other */
	{ 11,	0xfe,	1 },	/* sig found announce, saw first intro */
	{ 11,	-1,		0 },	/* sig found announce, saw other */
	{ -1,	-1,		-1 }	/* end marker */
};
