/* help.c, Boone, 09/29/04
   Help screen for xcatctl
   Copyright (C) 2004-2009, Dennis Boone, East Lansing, MI */

/* Modifications:
   09/29/04 Boone      Initial coding
   End Modifications */

/* This file is part of xcatctl.

   Xcatctl is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License,
   or (at your option) any later version.

   Xcatctl is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with xcatctl; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <stdio.h>

void help()
{
	fputs("       xcatctl [ options ]\n\
\n\
       --verbose\n\
              Produce output suitable for human, instead of machine,  consump-\n\
              tion.\n\
\n\
       --setvfofreq freq\n\
              Set  freq (specified in megahertz) as the operating frequency of\n\
              the VFO.  Note that you  should  set  duplex,  transmit  offset,\n\
              radio  band  and VCO split (v-bit shift) frequencies before set-\n\
              ting the operating frequency, as the xcat needs these values  to\n\
              correctly calculate the data required by the radio.\n\
\n\
       --setmode mode\n\
              Select  mode  as the \"current\" mode (memory channel).  Note that\n\
              selecting a mode does NOT copy its data into the VFO.\n\
\n\
       --storevfotomode\n\
              Store the configuration currently in the VFO  to  the  currently\n\
              selected mode (memory channel).\n\
\n\
       --storemodetovfo\n\
              Copy  the  configuration  data  from the currently selected mode\n\
              (memory channel) into the VFO, thus making them the radio's cur-\n\
              rent operating parameters.\n\
\n\
       --setduplex { simplex | negative | positive }\n\
              Set the duplex (transmit offset direction) of the radio as spec-\n\
              ified.  The size of any offset is selected using the --settxoff-\n\
              set option.\n\
\n\
       --settxpl plfreq\n\
              Set  plfreq  (specified  in  hertz)  as the transmit (encode) PL\n\
              (CTCSS) tone.  Use 0 to turn off PL.  Only standard PL tones can\n\
              be set; nonstandard tones will be rejected by the xcat board.  A\n\
              list of standard tones appears below.  Note that DPL  cannot  be\n\
              set  using  standard commands; you must use the direct code plug\n\
              loading functions to achieve DPL operation.\n\
\n\
       --setrxpl plfreq\n\
              Set plfreq (specified in  hertz)  as  the  receive  (decode)  PL\n\
              (CTCSS) tone.  Use 0 to turn off PL.  Only standard PL tones can\n\
              be set; nonstandard tones will be rejected by the xcat board.  A\n\
              list  of  standard tones appears below.  Note that DPL cannot be\n\
              set using standard commands; you must use the direct  code  plug\n\
              loading functions to achieve DPL operation.\n\
\n\
       --getvfocodeplug\n\
              Retrieve  the code plug data from the VFO and display it in hex.\n\
\n\
       --setvfocodeplug codeplugdata\n\
              Store one mode (channel) of codeplugdata  (16  bytes)  into  the\n\
              VFO.   The  format  of  the data should be the same as that dis-\n\
              played by the --getcodeplugdata  option.   Note  that  you  will\n\
              probably  have  to  quote  the hexadecimal string to get it past\n\
              your command interpreter/shell.  Loading mode  data  using  this\n\
              option  allows  more flexibility in configuring the radio, since\n\
              all code plug variables can be manipulated.  You  may  find  the\n\
              syntorxgen  (1)  and  loadplug (1) programs useful in generating\n\
              and loading such code plug data.\n\
\n\
       --getversion\n\
              Retrieve the firmware version number from the xcat  and  display\n\
              it.\n\
\n\
       --getconfig\n\
              Retrieve  the  two bytes of configuration data from the xcat and\n\
              display them in hexadecimal.\n\
\n\
       --setconfig\n\
              Using  the  default  values,  and/or  those  specified  by   the\n\
              --radioband,  --sendcos, --controlsys, and --io0..--io7 options,\n\
              change the configuration of the xcat.\n\
\n\
       --setconfigbits hexbytes\n\
              Use the two byte values specified by hexbytes to change the con-\n\
              figuration  of the xcat.  See the xcat documentation for the bit\n\
              maps needed to calculate the values.\n\
\n\
       --gettxoffset\n\
              Retrieve the value added to or subtracted from the receive  fre-\n\
              quency  by  the  xcat  to  determine the transmit frequency when\n\
              operating in positive or negative duplex  (offset)  modes.   The\n\
              value is displayed in hertz.\n\
\n\
       --settxoffset offset\n\
              Set  to offset the value added to or subtracted from the receive\n\
              frequency by the xcat to determine the transmit  frequency  when\n\
              operating  in  positive  or negative duplex (offset) modes.  The\n\
              value should be specified in hertz.   Note  that  changing  this\n\
              value  does  not  cause any immediate change in the operation of\n\
              the radio.  The value is only used by the  xcat  in  calculating\n\
              new  data when a frequency is set using the --setvfofreq option.\n\
\n\
       --getvcosplit\n\
              Retrieve the transmit and receive VCO splits (v-bit  shift  fre-\n\
              quencies)  currently  being  used by the xcat.  The Syntor X VCO\n\
              operates in several frequency ranges, typically two for transmit\n\
              and  two  for  receive.   The VCO splits determine at which fre-\n\
              quency the radio shifts from using the lower range to the  upper\n\
              range.\n\
\n\
       --setvcosplit\n\
              Set  the  VCO splits to the values specified by the --txvcosplit\n\
              and --rxvcosplit options.  There are no defaults for the splits,\n\
              and  specifying  --setvcosplit without also specifying --txvcos-\n\
              plit and -B --rxvcosplit is an error.  Note that these values do\n\
              not  cause  any  immediate change in the operation of the radio.\n\
              The value is only used by the xcat in calculating new data  when\n\
              a frequency is set using the --setvfofreq option.\n\
\n\
       --txvcosplit splitfreq\n\
              Make  splitfreq  the  transmit  VCO split frequency to be loaded\n\
              into the xcat by the --setvcosplit option.  The frequency should\n\
              be specified in megahertz.\n\
\n\
       --rxvcosplit splitfreq\n\
              Make splitfreq the receive VCO split frequency to be loaded into\n\
              the xcat by the --setvcosplit option.  The frequency  should  be\n\
              specified in megahertz.\n\
\n\
       --radioband { 10 | 10+6 | 6 | 440 }\n\
              Set the values in the config word which will be sent to the xcat\n\
              by --setconfig to indicate in which band of radio the  board  is\n\
              installed.  For VHF-HI radios, use \"440\".\n\
\n\
       --sendcos { yes | no }\n\
              Set the values in the config word which will be sent to the xcat\n\
              by --setconfig to indicate whether the xcat should send  or  not\n\
              send  indications  of channel activity to the attached computer.\n\
              These notifications are asynchronous.  Note  that  xcatctl  does\n\
              not have any mechanism for dealing with such notifications.\n\
\n\
       --controlsys { none | doughall | generic | palomar | cactus }\n\
              Set the values in the config word which will be sent to the xcat\n\
              by --setconfig to indicate which type of control system will  be\n\
              connected to the xcat.  The CI-V interface on the xcat is always\n\
              active.\n\
\n\
       --io0 .. --io7 { user | alternate }\n\
              Set the values in the config word which will be sent to the xcat\n\
              by --setconfig to indicate how the xcat should configure its I/O\n\
              pins.  See the xcat documentation for information  on  what  the\n\
              alternate functions of the pins are.\n\
\n\
       --toaddr civaddr\n\
              Set  the  CI-V  address  used by the xcat board.  The default is\n\
              0x20, and the only way to change the board is by hacking on  its\n\
              firmware.\n\
\n\
       --fromaddr civaddr\n\
              Set  the  CI-V  address  to  be used by xcatctl.  The default is\n\
              0xe0.\n\
\n\
       --serialport serialdevice\n\
              Set to serialdevice the name of the serial device (COM port)  on\n\
              the computer running xcatctl to which the xcat is connected.\n\
", stderr);
	}
