/* loadplug.c, Boone, 09/29/04
   Load a whole code plug into an xcat board
   Copyright (C) 2004-2009, Dennis Boone, East Lansing, MI */

/* Modifications:
   09/29/04 Boone      Initial coding
   07/03/09 Boone      Include string.h to eliminate compile warning
   End Modifications */

/* This file is part of xcatctl.

   Xcatctl is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License,
   or (at your option) any later version.

   Xcatctl is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with xcatctl; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int main(int argc, char *argv[])
{
	int i;
	int fileflag = 0;
	FILE *fh;
	char *envbuf;
	unsigned char codebuf[256];
	unsigned char cmdbuf[256];

/* Command line */

	for (i = 1; i < argc; i++)
	{
		if (! fileflag)
		{
			if (strcmp("-", argv[i]) == 0)
				fh = stdin;
			else
				fh = fopen(argv[i], "r");
			if (fh == NULL)
			{
				fprintf(stderr, "unable to open input file %s: %s\n",
					argv[i], strerror(errno));
				exit(errno);
			}
			fileflag = 1;
			continue;
		}
		fprintf(stderr, "invalid parameter [%s]\n", argv[i]);
		exit(EINVAL);
	}

/* Load the plug */

	envbuf = getenv("XCATCTLARGS");
	if (! envbuf)
		envbuf = "";
	i = 0;
	while (fgets(codebuf, 255, fh) != NULL)
	{
		snprintf(cmdbuf, 255, "xcatctl %s --setmode %d", envbuf, i+1);
		system(cmdbuf);
		codebuf[strlen(codebuf)-1] = 0;
		snprintf(cmdbuf, 255, "xcatctl %s --setvfocodeplug \"%s\"",
			envbuf, codebuf);
		system(cmdbuf);
		snprintf(cmdbuf, 255, "xcatctl %s --storevfotomode", envbuf);
		system(cmdbuf);
		i++;
		if (i > 31) break;
	}

/* Done */

	exit(0);
}
