/* saveplug.c, Boone, 09/29/04
   Save a whole code plug from an xcat board
   Copyright (C) 2009, Dennis Boone, East Lansing, MI */

/* Modifications:
   07/03/09 Boone      Initial coding
   End Modifications */

/* This file is part of xcatctl.

   Xcatctl is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2 of the License,
   or (at your option) any later version.

   Xcatctl is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with xcatctl; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int main(int argc, char *argv[])
{
	int i;
	int fileflag = 0;
	FILE *fh;
	int nmodesflag = 0;
	int nmodes = 32;
	char *envbuf;
	unsigned char cmdbuf[256];
	FILE *xch;
	unsigned char codebuf[256];

/* Command line */

	for (i = 1; i < argc; i++)
	{
		if (! fileflag)
		{
			if (strcmp("-", argv[i]) == 0)
				fh = stdout;
			else
				fh = fopen(argv[i], "w");
			if (fh == NULL)
			{
				fprintf(stderr, "unable to open output file %s: %s\n",
					argv[i], strerror(errno));
				exit(errno);
			}
			fileflag = 1;
			continue;
		}
		if (! nmodesflag)
		{
			nmodes = atoi(argv[i]);
			if (nmodes > 32)
			{
				fprintf(stderr, "number of modes may not exceed 32\n");
				exit(EINVAL);
			}
			continue;
		}
		fprintf(stderr, "invalid parameter [%s]\n", argv[i]);
		exit(EINVAL);
	}

/* Load the plug */

	envbuf = getenv("XCATCTLARGS");
	if (! envbuf)
		envbuf = "";
	i = 0;
	while (i < nmodes)
	{
		snprintf(cmdbuf, 255, "xcatctl %s --setmode %d", envbuf, i+1);
		system(cmdbuf);
		snprintf(cmdbuf, 255, "xcatctl %s --storemodetovfo", envbuf);
		system(cmdbuf);
		snprintf(cmdbuf, 255, "xcatctl %s --getvfocodeplug", envbuf);
		xch = popen(cmdbuf, "r");
		fgets(codebuf, 255, xch);
		codebuf[strlen(codebuf)-1] = 0;
		pclose(xch);
		i++;
	}

/* Done */

	exit(0);
}
